package exnihilocreatio;

import exnihilocreatio.blocks.*;
import exnihilocreatio.tiles.*;
import exnihilocreatio.util.Data;
import exnihilocreatio.util.IHasModel;
import net.minecraft.block.Block;
import net.minecraft.block.SoundType;
import net.minecraft.block.material.Material;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.registries.IForgeRegistry;

public class ModBlocks {


    public static final BlockBaseFalling dust;
    public static final BlockBaseFalling netherrackCrushed;
    public static final BlockBaseFalling endstoneCrushed;
    public static final BlockBarrel barrelWood;
    public static final BlockBarrel barrelStone;
    public static final BlockInfestedLeaves infestedLeaves;
    public static final BlockCrucible crucible;
    public static final BlockSieve sieve;

    public static final BlockWaterwheel watermill;
    public static final BlockStoneAxle axle_stone;

    public static final BlockGrinder grinder;
    public static final BlockAutoSifter autoSifter;

    static {
        dust = new BlockBaseFalling(SoundType.field_185854_g, "block_dust");
        dust.func_149647_a(ExNihiloCreatio.tabExNihilo);
        dust.func_149711_c(0.7F);

        netherrackCrushed = new BlockBaseFalling(SoundType.field_185849_b, "block_netherrack_crushed");
        netherrackCrushed.func_149647_a(ExNihiloCreatio.tabExNihilo);
        netherrackCrushed.func_149711_c(0.7F);

        endstoneCrushed = new BlockBaseFalling(SoundType.field_185849_b, "block_endstone_crushed");
        endstoneCrushed.func_149647_a(ExNihiloCreatio.tabExNihilo);
        endstoneCrushed.func_149711_c(0.7F);

        barrelWood = new BlockBarrel(0, Material.field_151575_d);
        barrelWood.func_149647_a(ExNihiloCreatio.tabExNihilo);

        barrelStone = new BlockBarrel(1, Material.field_151576_e);
        barrelStone.func_149647_a(ExNihiloCreatio.tabExNihilo);
        GameRegistry.registerTileEntity(TileBarrel.class, "block_barrel");

        infestedLeaves = new BlockInfestedLeaves();
        GameRegistry.registerTileEntity(TileInfestedLeaves.class, "block_infested_leaves");
        infestedLeaves.func_149647_a(ExNihiloCreatio.tabExNihilo);

        crucible = new BlockCrucible();
        crucible.func_149647_a(ExNihiloCreatio.tabExNihilo);
        GameRegistry.registerTileEntity(TileCrucible.class, "block_crucible");

        sieve = new BlockSieve();
        sieve.func_149647_a(ExNihiloCreatio.tabExNihilo);
        GameRegistry.registerTileEntity(TileSieve.class, "block_sieve");


        watermill = new BlockWaterwheel();
        GameRegistry.registerTileEntity(TileWaterwheel.class, "block_waterwheel");

        axle_stone = new BlockStoneAxle();
        GameRegistry.registerTileEntity(TileStoneAxle.class, "block_axle_stone");

        grinder = new BlockGrinder();
        GameRegistry.registerTileEntity(TileGrinder.class, "block_grinder");

        autoSifter = new BlockAutoSifter();
        GameRegistry.registerTileEntity(TileAutoSifter.class, "block_auto_sifter");

    }

    public static void registerBlocks(IForgeRegistry<Block> registry) {
        for (Block block : Data.BLOCKS) {
            registry.register(block);
        }
    }

    @SideOnly(Side.CLIENT)
    public static void initModels(ModelRegistryEvent e) {
        for (Block block : Data.BLOCKS) {
            if (block instanceof IHasModel) {
                ((IHasModel) block).initModel(e);
            }
        }
    }
}
