package exnihilocreatio.client.renderers;

import exnihilocreatio.blocks.BlockAutoSifter;
import exnihilocreatio.blocks.EnumAutoSifterParts;
import exnihilocreatio.config.Config;
import exnihilocreatio.tiles.TileAutoSifter;
import exnihilocreatio.tiles.TileSieve;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.*;
import net.minecraft.client.renderer.block.model.BakedQuad;
import net.minecraft.client.renderer.texture.TextureAtlasSprite;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.client.renderer.tileentity.TileEntitySpecialRenderer;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.Tuple;
import net.minecraft.util.math.BlockPos;
import org.lwjgl.opengl.GL11;

import javax.vecmath.Point3f;
import java.util.List;

public class RenderAutoSifter extends TileEntitySpecialRenderer<TileAutoSifter> {
    private static List<BakedQuad> quadsBox;
    private static List<BakedQuad> quadsGear;
    private static List<BakedQuad> quadsShaft;
    private static List<BakedQuad> quadsConnection;

    @Override
    public void func_192841_a(TileAutoSifter te, double x, double y, double z, float partialTicks, int destroyStage, float alpha) {
        if (te.toSift != null && Config.clientFancyAutoSieveAnimations) {
            for (TileSieve[] tileSieves : te.toSift) {
                for (TileSieve tileSieve : tileSieves) {
                    if (tileSieve != null) {
                        BlockPos blockPos = tileSieve.func_174877_v();
                        renderPiston(te, blockPos.func_177958_n() - te.func_174877_v().func_177958_n() + x, blockPos.func_177956_o() - te.func_174877_v().func_177956_o() + y - 1, blockPos.func_177952_p() - te.func_174877_v().func_177952_p() + z);
                    }
                }
            }
        }

        if (te.connectionPieces != null && Config.clientFancyAutoSieveAnimations) {
            for (Tuple<Point3f, EnumFacing.Axis> connectionPiece : te.connectionPieces) {
                renderConnection(te, x + connectionPiece.func_76341_a().x, y + connectionPiece.func_76341_a().y, z + connectionPiece.func_76341_a().z, connectionPiece.func_76340_b());
            }
        }

        renderRod(te, x, y, z, partialTicks);
        renderBox(te, x, y, z);

        renderIngredients(te, x, y, z, partialTicks);
    }

    private void renderPiston(TileAutoSifter tile, double x, double y, double z) {
        if (quadsGear == null) {
            final BlockRendererDispatcher blockRenderer = Minecraft.func_71410_x().func_175602_ab();
            IBlockState state = tile.func_145838_q().func_176223_P().func_177226_a(BlockAutoSifter.PART_TYPE, EnumAutoSifterParts.PISTON);

            quadsGear = blockRenderer.func_184389_a(state).func_188616_a(state, null, 0);
        }

        Tessellator tessellator = Tessellator.func_178181_a();
        GlStateManager.func_179094_E();

        GlStateManager.func_179137_b(x, y, z);
        GlStateManager.func_179137_b(0.5, 0.5, 0.5);
        GlStateManager.func_179139_a(0.5, 0.5, 0.5);

        GlStateManager.func_179112_b(770, 771);
        GlStateManager.func_179147_l();
        GlStateManager.func_179129_p();


        GlStateManager.func_179109_b(tile.offsetX, 0.8F, tile.offsetZ);


        RenderHelper.func_74518_a();

        Minecraft.func_71410_x().field_71446_o.func_110577_a(TextureMap.field_110575_b);

        BufferBuilder worldRendererBuffer = tessellator.func_178180_c();

        worldRendererBuffer.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_176600_a);
        // worldRendererBuffer.setTranslation(-.5, -.5, -.5);

        RenderUtils.renderModelTESRFast(quadsGear, worldRendererBuffer, tile.func_145831_w(), tile.func_174877_v());

        // worldRendererBuffer.setTranslation(0, 0, 0);
        tessellator.func_78381_a();

        GlStateManager.func_179121_F();
        RenderHelper.func_74519_b();

        GlStateManager.func_179084_k();
        GlStateManager.func_179089_o();
    }

    private void renderConnection(TileAutoSifter tile, double x, double y, double z, EnumFacing.Axis axis) {
        if (quadsConnection == null) {
            final BlockRendererDispatcher blockRenderer = Minecraft.func_71410_x().func_175602_ab();
            IBlockState state = tile.func_145838_q().func_176223_P().func_177226_a(BlockAutoSifter.PART_TYPE, EnumAutoSifterParts.CONNECTION);

            quadsConnection = blockRenderer.func_184389_a(state).func_188616_a(state, null, 0);
        }

        /*
        int xRel = blockPos.getX() - te.getPos().getX() + x;
        int yRel = blockPos.getY() - te.getPos().getY() + y - 1;
        int zRel = blockPos.getZ() - te.getPos().getZ() + z;*/

        Tessellator tessellator = Tessellator.func_178181_a();
        GlStateManager.func_179094_E();

        GlStateManager.func_179137_b(x, y, z);
        GlStateManager.func_179137_b(0.5, 0.5, 0.5);
        GlStateManager.func_179139_a(0.5, 0.5, 0.5);

        GlStateManager.func_179112_b(770, 771);
        GlStateManager.func_179147_l();
        GlStateManager.func_179129_p();

        GlStateManager.func_179109_b(tile.offsetX, 0.0F, tile.offsetZ);

        // float rotFacing = tile.facing == EnumFacing.SOUTH ? 180 : tile.facing == EnumFacing.WEST ? 90 : tile.facing == EnumFacing.EAST ? -90 : 0;

        if (axis == EnumFacing.Axis.Z)
            GlStateManager.func_179114_b(90, 0, 1, 0);

        // if (tile.canTurn){
        //     tile.rotationValue = (tile.rotationValue + tile.perTickEffective) % 360;
        // }

        // GlStateManager.rotate(System.currentTimeMillis() % 360, 0, 1, 0);
        // GlStateManager.translate(0, (float)(System.currentTimeMillis() % 200) / 200F, 0);


        RenderHelper.func_74518_a();

        Minecraft.func_71410_x().field_71446_o.func_110577_a(TextureMap.field_110575_b);

        BufferBuilder worldRendererBuffer = tessellator.func_178180_c();

        worldRendererBuffer.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_176600_a);
        // worldRendererBuffer.setTranslation(-.5, -.5, -.5);

        RenderUtils.renderModelTESRFast(quadsConnection, worldRendererBuffer, tile.func_145831_w(), tile.func_174877_v());

        // worldRendererBuffer.setTranslation(0, 0, 0);
        tessellator.func_78381_a();

        GlStateManager.func_179121_F();
        RenderHelper.func_74519_b();

        GlStateManager.func_179084_k();
        GlStateManager.func_179089_o();
    }

    private void renderRod(TileAutoSifter tile, double x, double y, double z, float partialTicks) {
        if (quadsShaft == null) {
            final BlockRendererDispatcher blockRenderer = Minecraft.func_71410_x().func_175602_ab();
            IBlockState state = tile.func_145838_q().func_176223_P().func_177226_a(BlockAutoSifter.PART_TYPE, EnumAutoSifterParts.ROD);

            quadsShaft = blockRenderer.func_184389_a(state).func_188616_a(state, null, 0);
        }

        Tessellator tessellator = Tessellator.func_178181_a();
        GlStateManager.func_179094_E();

        GlStateManager.func_179137_b(x, y, z);
        GlStateManager.func_179137_b(0.5, 0.5, 0.5);
        GlStateManager.func_179139_a(0.5, 0.5, 0.5);


        GlStateManager.func_179112_b(770, 771);
        GlStateManager.func_179147_l();
        GlStateManager.func_179129_p();


        float rotFacing = tile.facing == EnumFacing.SOUTH ? 180 : tile.facing == EnumFacing.WEST ? 90 : tile.facing == EnumFacing.EAST ? -90 : 0;
        GlStateManager.func_179114_b(rotFacing, 0, 1, 0);

        float rot = (tile.rotationValue + tile.perTickRotation * partialTicks) % 360;
        GlStateManager.func_179114_b(rot, 0, 0, 1);


        RenderHelper.func_74518_a();

        Minecraft.func_71410_x().field_71446_o.func_110577_a(TextureMap.field_110575_b);

        BufferBuilder worldRendererBuffer = tessellator.func_178180_c();

        worldRendererBuffer.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_176600_a);
        // worldRendererBuffer.setTranslation(-.5, -.5, -.5);

        RenderUtils.renderModelTESRFast(quadsShaft, worldRendererBuffer, tile.func_145831_w(), tile.func_174877_v());

        // worldRendererBuffer.setTranslation(0, 0, 0);
        tessellator.func_78381_a();

        GlStateManager.func_179121_F();
        RenderHelper.func_74519_b();

        GlStateManager.func_179084_k();
        GlStateManager.func_179089_o();
    }

    private void renderBox(TileAutoSifter tile, double x, double y, double z) {
        if (quadsBox == null) {
            final BlockRendererDispatcher blockRenderer = Minecraft.func_71410_x().func_175602_ab();
            IBlockState state = tile.func_145838_q().func_176223_P().func_177226_a(BlockAutoSifter.PART_TYPE, EnumAutoSifterParts.BOX);

            quadsBox = blockRenderer.func_184389_a(state).func_188616_a(state, null, 0);
        }

        Tessellator tessellator = Tessellator.func_178181_a();
        GlStateManager.func_179094_E();

        GlStateManager.func_179137_b(x, y, z);
        GlStateManager.func_179137_b(0.5, 0.5, 0.5);
        GlStateManager.func_179139_a(0.5, 0.5, 0.5);


        GlStateManager.func_179112_b(770, 771);
        GlStateManager.func_179147_l();
        GlStateManager.func_179129_p();


        RenderHelper.func_74518_a();

        Minecraft.func_71410_x().field_71446_o.func_110577_a(TextureMap.field_110575_b);

        BufferBuilder worldRendererBuffer = tessellator.func_178180_c();

        worldRendererBuffer.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_176600_a);
        // worldRendererBuffer.setTranslation(-.5, -.5, -.5);

        RenderUtils.renderModelTESRFast(quadsBox, worldRendererBuffer, tile.func_145831_w(), tile.func_174877_v());

        // worldRendererBuffer.setTranslation(0, 0, 0);
        tessellator.func_78381_a();

        GlStateManager.func_179121_F();
        RenderHelper.func_74519_b();

        GlStateManager.func_179084_k();
        GlStateManager.func_179089_o();
    }


    private void renderIngredients(TileAutoSifter tile, double x, double y, double z, float partialTicks) {
        GlStateManager.func_179094_E();
        GlStateManager.func_179137_b(x, y, z);

        Tessellator tessellator = Tessellator.func_178181_a();
        BufferBuilder worldRendererBuffer = tessellator.func_178180_c();

        // GlStateManager.translate(0, 1, 0);

        if (tile.getTexture() != null) {
            TextureAtlasSprite icon = tile.getTexture();
            double minU = (double) icon.func_94209_e();
            double maxU = (double) icon.func_94212_f();
            double minV = (double) icon.func_94206_g();
            double maxV = (double) icon.func_94210_h();

            this.func_147499_a(TextureMap.field_110575_b);

            worldRendererBuffer.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_181710_j);

            double height = (float) tile.itemHandlerAutoSifter.getStackInSlot(0).func_190916_E() / (float) tile.itemHandlerAutoSifter.getSlotLimit(0);

            // float fillAmount = (float) (height);
            float fillAmount = (float) (0.5 * height + 0.0625);

            worldRendererBuffer.func_181662_b(0.0625f, fillAmount, 0.0625f).func_187315_a(minU, minV).func_181663_c(0, 1, 0).func_181675_d();
            worldRendererBuffer.func_181662_b(0.0625f, fillAmount, 0.9375f).func_187315_a(minU, maxV).func_181663_c(0, 1, 0).func_181675_d();
            worldRendererBuffer.func_181662_b(0.9375f, fillAmount, 0.9375f).func_187315_a(maxU, maxV).func_181663_c(0, 1, 0).func_181675_d();
            worldRendererBuffer.func_181662_b(0.9375f, fillAmount, 0.0625f).func_187315_a(maxU, minV).func_181663_c(0, 1, 0).func_181675_d();

            tessellator.func_78381_a();
        }

        GlStateManager.func_179084_k();
        GlStateManager.func_179145_e();
        GlStateManager.func_179121_F();
    }
}
